## Summary

> [!warning]

Table `<%= table_metadata['table_name'] %>` is rapidly growing toward our limits. It requires immediate attention to prevent performance degradation.

## Details

| Date | Identifier | Total size | Table size | Index size | Classification |
| -------- | -------- | -------- | -------- | -------- | -------- |
| `<%= Date.current %>` | `<%= table_metadata['identifier'] %>` | `<%= table_metadata['total_size'] %>` | `<%= table_metadata['table_size'] %>` | `<%= table_metadata['index_size'] %>` | `<%= table_metadata['classification'] %>` |

## Growth Concerns

- The current classification is **<%= table_metadata['classification'] %>**, but the rapid growth rate indicates action is required.

## Recommended Actions

1. **Retention**: Delete unnecessary data, for example expire old and unneeded records.
1. **Index optimization**: Drop unnecessary indexes and consolidate overlapping indexes if possible.
1. **Optimize data types**: Review data type decisions and optimize data types where possible (example: use integer instead of text for an enum column)
1. **Partitioning**: Apply a partitioning scheme if there is a common access dimension.
1. **Normalization**: Review relational modeling and apply normalization techniques to remove duplicate data
1. **Vertical table splits**: Review column usage and split table vertically.
1. **Externalize**: Move large data types out of the database entirely. For example, JSON documents, especially when not used for filtering, may be better stored outside the database, for example, in object storage.

Reach out to [#database-sustainability](<%= slack_url %>) for assistance.

## Impact

Without action: degraded code review performance, increased maintenance overhead, and potential service disruptions.

## Documentation

- [Large tables limitations](<%= limitations_url %>)
- [Retention policy guidelines](<%= retentions_url %>)
- [Blueprint](<%= blueprint_url %>)

<!-- <%= OpenSSL::Digest::SHA256.hexdigest(table_metadata['identifier']) %> -->
<!-- STATUS NOTE START --><!-- STATUS NOTE END -->
